package com.zhentao.controller.user;

import com.zhentao.domain.UserLogin;
import com.zhentao.dto.user.*;
import com.zhentao.dto.Result;
import com.zhentao.service.UserLoginService;
import io.minio.errors.*;
import jdk.nashorn.internal.runtime.regexp.joni.exception.InternalException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import java.io.IOException;
import java.rmi.ServerException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

@RestController
@RequestMapping("user")
public class UserController {
    @Autowired
    public UserLoginService service;
//    登录
    @PostMapping("/login")
    public Result Login(@RequestBody @Valid UserDto userDto){
        return service.login(userDto);
    }
//    获取验证码
    @PostMapping("/code")
    public Result Code(@RequestBody @Valid NoteDto noteDto){
        System.err.println(noteDto);
        return service.note(noteDto);
    }
//    账号密码登录
    @PostMapping("/loginup")
    public Result Loginup(@RequestBody @Valid UserDtoup userDtoup){
        System.err.println(userDtoup);
        return service.login_up(userDtoup);
    }
//    注册
    @PostMapping("/register")
    public Result Register(@RequestBody @Valid UserRegister userRegister){
        return service.register(userRegister);
    }


    //上传
    @RequestMapping("/uploadPicture")
    public Result uploadPicture(@RequestBody MultipartFile multipartFile, Long id) throws ServerException, InsufficientDataException, ErrorResponseException, IOException, NoSuchAlgorithmException, InvalidKeyException, InvalidResponseException, XmlParserException, InternalException, io.minio.errors.ServerException, InvalidKeyException, io.minio.errors.InternalException, InvalidBucketNameException {
        return service.uploadPicture(multipartFile,id);
    }

    //查询用户信息
    @RequestMapping("/getUserInfo")
    public UserLogin getUserInfo(@RequestParam("id") Long id){
        return service.getUserInfo(id);
    }

    //修改密码
    @RequestMapping("/updatePassword")
    public Result updatePassword(@RequestParam("username") String username,@RequestParam("oldPassword") String oldPassword,@RequestParam("newPassword") String newPassword){
        return service.updatePassword(username,oldPassword,newPassword);
    }


    //修改个人信息
    @RequestMapping("/updateUserInfo")
    public String updateUserInfo(@RequestBody UserInfoDto userInfoDto) {
        // 这里假设从JWT中解析获取当前登录用户的userId，实际需根据你的登录鉴权逻辑调整
        Long userId = getUserIdFromJwt();
        boolean result = service.updateUserInfo(userInfoDto, userId);
        if (result) {
            return "个人信息修改成功";
        } else {
            return "个人信息修改失败";
        }
    }

    // 模拟从JWT获取userId的方法，实际需根据具体JWT解析逻辑实现
    private Long getUserIdFromJwt() {
        // 这里简单返回一个示例值，实际应从JWT中解析
        return 1L;
    }
}
