package com.zhentao.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

/**
 * 课程表
 * @TableName courses
 */
@TableName(value ="courses")
@Data
public class Courses implements Serializable {
    /**
     * 主键
     */
    @TableId
    @JsonSerialize(using = ToStringSerializer.class)
    private Long courseId;

    /**
     * 课程标题
     */
    private String courseTitle;

    /**
     * 课程分类id
     */
    private Long categoryId;

    /**
     * 课程主图的url地址
     */
    private String mainImage;

    /**
     * 课程缩略图的url地址
     */
    private String thumbnailImage;

    /**
     * 课程所属店铺
     */
    private String store;

    /**
     * 价格
     */
    private BigDecimal price;

    /**
     * 课程的创建时间
     */
    private Date coursesCreatetime;

    /**
     * 店铺id
     */
    private Long storeId;

    /**
     * 授课老师id
     */
    private Long teacherId;

    /**
     * 授课老师名称
     */
    private String teacherName;

    /**
     * 备注
     */
    private String sub;
    @TableField(exist = false)
    private Shop shop;
    @TableField(exist = false)
    private CourseDatails courseDatails;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
