package com.zhentao.service;

import com.zhentao.domain.UserLogin;
import com.baomidou.mybatisplus.extension.service.IService;
import com.zhentao.dto.user.*;
import com.zhentao.dto.Result;
import io.minio.errors.*;
import jdk.nashorn.internal.runtime.regexp.joni.exception.InternalException;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.rmi.ServerException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

/**
* @author 86183
* @description 针对表【user_login(用户)】的数据库操作Service
* @createDate 2025-05-04 21:01:51
*/
public interface UserLoginService extends IService<UserLogin> {
    //    手机号登录
    Result login(UserDto userDto);

    //    短信
    Result note(NoteDto noteDto);
    //    账号密码登录
    Result login_up(UserDtoup userDtoup);
    //    注册
    Result register(UserRegister userRegister);
    //图片上传
    Result uploadPicture(MultipartFile multipartFile, Long id) throws IOException, ServerException, InvalidBucketNameException, InsufficientDataException, ErrorResponseException, NoSuchAlgorithmException, InvalidKeyException, InvalidResponseException, XmlParserException, InternalException, io.minio.errors.ServerException, InvalidKeyException, io.minio.errors.InternalException;

    //    获取用户信息 根据id查询数据
    UserLogin getUserInfo(Long id);

    //修改密码
    Result updatePassword(String username, String oldPassword, String newPassword);
    //修改个人信息
    boolean updateUserInfo(UserInfoDto userInfoDto, Long userId);
}
